// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	securityv1 "github.com/openshift/api/security/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRangeAllocations implements RangeAllocationInterface
type FakeRangeAllocations struct {
	Fake *FakeSecurityV1
}

var rangeallocationsResource = schema.GroupVersionResource{Group: "security.openshift.io", Version: "v1", Resource: "rangeallocations"}

var rangeallocationsKind = schema.GroupVersionKind{Group: "security.openshift.io", Version: "v1", Kind: "RangeAllocation"}

// Get takes name of the rangeAllocation, and returns the corresponding rangeAllocation object, and an error if there is any.
func (c *FakeRangeAllocations) Get(name string, options v1.GetOptions) (result *securityv1.RangeAllocation, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(rangeallocationsResource, name), &securityv1.RangeAllocation{})
	if obj == nil {
		return nil, err
	}
	return obj.(*securityv1.RangeAllocation), err
}

// List takes label and field selectors, and returns the list of RangeAllocations that match those selectors.
func (c *FakeRangeAllocations) List(opts v1.ListOptions) (result *securityv1.RangeAllocationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(rangeallocationsResource, rangeallocationsKind, opts), &securityv1.RangeAllocationList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &securityv1.RangeAllocationList{ListMeta: obj.(*securityv1.RangeAllocationList).ListMeta}
	for _, item := range obj.(*securityv1.RangeAllocationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested rangeAllocations.
func (c *FakeRangeAllocations) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(rangeallocationsResource, opts))
}

// Create takes the representation of a rangeAllocation and creates it.  Returns the server's representation of the rangeAllocation, and an error, if there is any.
func (c *FakeRangeAllocations) Create(rangeAllocation *securityv1.RangeAllocation) (result *securityv1.RangeAllocation, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(rangeallocationsResource, rangeAllocation), &securityv1.RangeAllocation{})
	if obj == nil {
		return nil, err
	}
	return obj.(*securityv1.RangeAllocation), err
}

// Update takes the representation of a rangeAllocation and updates it. Returns the server's representation of the rangeAllocation, and an error, if there is any.
func (c *FakeRangeAllocations) Update(rangeAllocation *securityv1.RangeAllocation) (result *securityv1.RangeAllocation, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(rangeallocationsResource, rangeAllocation), &securityv1.RangeAllocation{})
	if obj == nil {
		return nil, err
	}
	return obj.(*securityv1.RangeAllocation), err
}

// Delete takes name of the rangeAllocation and deletes it. Returns an error if one occurs.
func (c *FakeRangeAllocations) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(rangeallocationsResource, name), &securityv1.RangeAllocation{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRangeAllocations) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(rangeallocationsResource, listOptions)

	_, err := c.Fake.Invokes(action, &securityv1.RangeAllocationList{})
	return err
}

// Patch applies the patch and returns the patched rangeAllocation.
func (c *FakeRangeAllocations) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *securityv1.RangeAllocation, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(rangeallocationsResource, name, pt, data, subresources...), &securityv1.RangeAllocation{})
	if obj == nil {
		return nil, err
	}
	return obj.(*securityv1.RangeAllocation), err
}
