/*
Copyright 2019 The Rook Authors. All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package v1

import (
	rook "github.com/rook/rook/pkg/apis/rook.io/v1alpha2"
)

// GetMgrPlacement returns the placement for the MGR service
func GetMgrPlacement(p rook.PlacementSpec) rook.Placement {
	return p.All().Merge(p[KeyMgr])
}

// GetTargetPlacement returns the placement for the Target service
func GetTargetPlacement(p rook.PlacementSpec) rook.Placement {
	return p.All().Merge(p[KeyTarget])
}

// GetPreparePlacement returns the placement for the Host Prepare service
func GetPreparePlacement(p rook.PlacementSpec) rook.Placement {
	return p.All().Merge(p[KeyPrepare])
}
